'Sprite Editor SprEd
'Martin Herhaus 2022 for Picomite VGA and other MM Basic devices
'
'V1.02:
'Enhancement
'Save and load Sprites in/from compressed File Format
' selectable BG Color for New Sprite
'Bugfix:
' removed an unnessecary "ELSE" Statement
'
'V1.01:
'Enhancement
' Added LCD ILI9341 Support
' Size now Up to 64x64 Pixel

'Bugfix:
'* Centered Sprite in Preview window
'* fixed Rotaton for non squared Sprites
'
Option explicit
Dim Col%(15),But$(15) length 22,Butc%(15,2),fname$,pxl$
Dim integer found,em,cx,cy,SH,SW,f%,n,i,xofs,yofs,cmp
Dim float XStp,YStp
Dim Buff%(4096),Buff2%(4096)
'which Platform?
Select Case MM.Device$
  Case "PicoMite"
  'hope there is an LCD
     If  MM.Info(LCDPANEL)<> "ILI9341" Then Print "No supported Device found":End
  Case "PicoMiteVGA"
    MODE 2
  Case Else
    MODE 7
End Select
Font 7

Restore colors:For f%=1 To 15:Read Col%(f%):Next f%
'Setup UD Graphics
Restore pict
For f%=1 To 15
    But$(f%)="":For n=1 To 22:Read i:But$(f%)=But$(f%)+Chr$(i):Next
Next f%
SH=24:SW=24
XStp=240/SW:YStp=240/SH:xofs=256+32-(SW/2):yofs=32-SH/2
Workbench
'main
 Do
  keys
 Loop

Sub keys
   Local ky$
   ky$=Inkey$
   Select Case ky$
     Case ""
       Exit Sub
     'cursor
    Case Chr$(128):resBlk:Inc cy,-1*(cy>0):setBlk:Exit Sub
    Case Chr$(129):resBlk:Inc cy,1*(cy<(sh-1)):setBlk:Exit Sub
    Case Chr$(130):resBlk:Inc cx,-1*(cx>0):setBlk:Exit Sub
    Case Chr$(131):resBlk:Inc cx,1*(cx<(sw-1)):setBlk:Exit Sub
   ' Colors
    Case "0" To "9","a" To "f"
      Box cx*xstp,cy*ystp,xstp+1,ystp+1,,Col%(8),col%(Val("&H"+ky$))
    cpDsp
    'F1
    Case Chr$(145):fname$=Dialog$("Load File, Name?"):fread(fname$)
    'F2
    Case Chr$(146):fname$=Dialog$("Save File, Name?"):fwrite(fname$)
    Case "n":New_sprite
    Case "s":cpDsp:For I=1 To sh*sw:Buff2%(i)=Buff%(i):Next
    Case "p":For I=1 To sh*sw:Buff%(i)=Buff2%(i):Next :rstDsp
    Case "r":RotR:cpDsp
    Case "l":RotL:cpDsp
    Case "h":MirH:cpDsp
    Case "o":ShiftU:cpDsp
    Case "k":ShiftD:cpDsp
    Case "q":ShiftL:cpDsp
    Case "w":shiftR:cpDsp
    Case "v":mirV:cpDsp
  End Select
  paint
End Sub

Sub New_sprite
Local ans$,SW1,SH1,bc
SW1=0:SH1=0:bc=-1
Do
  ans$=Dialog$("New Sprite:With (8 to 64)")
  If Val(ans$)>=8 And Val(ans$)<65 Then SW1=Val(ans$)
Loop Until SW1<>0
Do
  ans$=Dialog$("Height (8 to 64)")
  If Val(ans$)>=8 And Val(ans$)<65 Then SH1=Val(ans$)
Loop Until SH1<>0
Do
  ans$=Dialog$("Bg Color (0 to F)")
  If Val("&H"+ans$)>=0 And Val("&H"+ans$)<16 Then bc= Val("&H"+ans$)
Loop Until bc<>-1
For I=0 To SW1*SH1:Buff%(I)=col%(bc):Next
SW=SW1:SH=SH1:XStp=Int(240/SW):YStp=Int(240/SH)
xofs=256+32-(SW/2):yofs=32-SH/2:cx=0:cy=0
workbench
End Sub

Sub wind
 'Box 21,45,198,46,,0,col%(7)
 Box 23,47,194,42,,0,col%(7)
End Sub

Function Dialog$(inp$)
cpDsp
  wind
  Text 30,45,inp$
  Print @(28,60);
  Input Dialog$
  rstDsp
End Function

Sub fwrite fname$
  Local integer x,y,cnt,cl
  Local ans$,row$
  Do
    cmp=-1
    ans$=Dialog$("Save Compressed (Y/N)")
    If UCase$(ans$)="Y" Then cmp=1 Else cmp=0
  Loop Until cmp<>-1
  Open fname$ For output As #1
  cnt=0
  Print #1,Str$(sw);",1,";Str$(sh)
  For y=1 To sh
  row$=""
    For x=1 To sw
      cl=Buff%(cnt)
      row$=row$+Hex$(getColnr(cl),1)
      Inc cnt
      Next x
      If cmp Then row$=compress$(row$)
      Print #1,row$
    Next y
  Close #1
End Sub

Sub fread fname$
'Read Sprite from File
 Local integer x,y,cm1,cm2
 Local a$,dx$,b$
 For x=0 To 4095:Buff%(x)=0:Next
 Open fname$ For input As #1
    Line Input #1,dx$
    cm1=Instr(dx$,","):cm2=Instr(cm1+1,dx$,",")
    SW=Val(Left$(dx$,cm1-1))
    SH=Val(Right$(dx$,Len(dx$)-cm2))
    For y=0 To SH-1
        If Eof(1) Then Exit
        Line Input #1,b$
        a$=expand$(b$)
        For x=1 To Len(a$)
            Buff%(y*Sw+x-1)=Col%(Val("&H"+Mid$(a$,x,1)))
        Next x
    Next y
 Close #1
 XStp=Int(240/SW):YStp=Int(240/SH):xofs=256+32-SW/2:yofs=32-SH/2
 cx=0:cy=0
 workbench
End Sub

Function expand$(pxl$)
  Local n%,nmb%,tmp$,co$
  n%=1
  Do
   If Asc(Mid$(pxl$,n%,1))< 71 Then
      tmp$=tmp$+Mid$(pxl$,n%,1)
   Else
      ' length encoded - 1st char is pixel colour+71, 2nd is count-1
      co$=Hex$(Asc(Mid$(pxl$,n%,1))-71)
      Inc n%
      nmb%=Val("&H"+Mid$(pxl$,n%,1))
      tmp$=tmp$+String$(nmb%+1,co$)
   EndIf
   Inc n%
  Loop Until n%>Len(pxl$)
  expand$=tmp$
End Function
Sub Test123
Print expand$("ABA23H7121")
End Sub


Function getColnr(val)
Local integer cnt
If val=0 Then getColnr=0:Exit Function
cnt=1
Do
  If val=col%(cnt) Then getColnr=cnt:Exit Function
  Inc cnt:If cnt>15 Then getColnr=0:Exit Function
Loop
End Function

Sub mirV
  Local integer x,y
  cpDsp
  For y=0 To SH-1:For x=0 To SW-1
    Box x*xstp,(sh-y-1)*ystp,xstp+1,ystp+1,,Col%(7),Buff%(y*SW+x)
  Next :Next
End Sub

Sub mirh
  Local integer x,y
  cpDsp
  For y=0 To SH-1:For x=0 To SW-1
    Box (sw-x-1)*xstp,y*ystp,xstp+1,ystp+1,,Col%(7),Buff%(y*SW+x)
  Next :Next
End Sub

Sub ShiftL
  Local integer x,y,v
  cpDsp
  For y=0 To SH-1:v=Buff%(y*sw)
    For x=0 To SW-2:Buff%(y*sw+x)=Buff%(y*sw+x+1):Next
    Buff%(y*sw+sw-1)=v
  Next
  rstDsp
End Sub

Sub ShiftR
  Local integer x,y,v
  cpDsp
  For y=0 To SH-1:v=Buff%(y*sw+sw-1)
    For x=SW-1 To 1 Step -1
      Buff%(y*sw+x)=Buff%(y*sw+x-1)
    Next
    Buff%(y*sw)=v
  Next
  rstDsp
End Sub

Sub ShiftU
  Local integer x,y,v
  cpDsp
  For x=0 To Sw-1:v=Buff%(x)
    For y=0 To SH-2:Buff%(y*sw+x)=Buff%(y*sw+sw+x):Next
    Buff%(x+(sh-1)*sw)=v
  Next
  rstDsp
End Sub

Sub ShiftD
  Local integer x,y,v
  cpDsp
  For x=0 To Sw-1:v=Buff%(x+(sh-1)*sw)
    For y=sh-2 To 0 Step -1:Buff%(y*sw+sw+x)=Buff%(y*sw+x):Next y
    Buff%(x)=v
  Next x
  rstDsp
End Sub

Sub RotL
  Local integer x,y
  cpDsp
  If SW=SH Then
  For y=0 To SH-1:For x=0 To SW-1
    Box y*ystp,((SW-1)-x)*xstp,xstp+1,ystp+1,,Col%(7),Buff%(y*SW+x)
  Next :Next
  Else
  For y=0 To SH-1 :For x=0 To SW-1
    buff2%((sw-x-1)*sh+y)=Buff%(y*SW+x)
  Next :Next
  Y=SW:SW=SH:SH=Y:For x=0 To (SW*SH)-1:buff%(x)=Buff2%(x):Next
  xofs=256+32-SW/2:yofs=32-SH/2
  workbench

  EndIf
End Sub

Sub RotR
  Local integer x,y
  cpDsp
  If SW=SH Then
  For y=0 To SH-1 :For x=0 To SW-1
    Box (SW-1-y)*ystp,x*xstp,xstp+1,ystp+1,,Col%(7),Buff%(y*SW+x)
 Next :Next
 Else
  For y=0 To SH-1 :For x=0 To SW-1
    buff2%((sh-y-1)+(x*sh))=Buff%(y*SW+x)
  Next :Next
  Y=SW:SW=SH:SH=Y:For x=0 To (SW*SH)-1:buff%(x)=Buff2%(x):Next
  xofs=256+32-SW/2:yofs=32-SH/2
  workbench
 EndIf
End Sub

Sub cpDsp
  Local integer x,y
  For y=0 To SH-1:For x=0 To SW-1
    Buff%(y*SW+x)=Pixel(1+(x*xstp),1+(y*ystp))
  Next :Next
End Sub

Sub rstDsp
  Local integer x,y
  XStp=Int(240/SW):YStp=Int(240/SH)
  For y=0 To SH-1:For x=0 To SW-1
    Box Int(x*xstp),Int(y*ystp),xstp+1,ystp+1,,Col%(7),Buff%(y*SW+x)
  Next
Next
End Sub

Sub resBlk
   Box cx*xstp,cy*ystp,xstp+1,ystp+1,,Col%(7)
End Sub

Sub setBlk
   Box cx*xstp,cy*ystp,xstp+1,ystp+1,,Col%(8)
End Sub

Sub Workbench
  Local integer x,y,f%
  CLS :Font 4:For x=0 To 28:Text 0,x*8,String$(40,177):Next :Font 7
  For f%=0 To 15
    Box 246,96+f*9,26,9,,col%(f%),Col%(f%):Text 256,97+f*9,Hex$(F%,1)
  Next
  Box 246,96,26,244,,Col%(14):Box 320-64,0,64,64,,col%(14),col%(7)
  Restore buttons
  For f%=1 To 13:Read x,y
    But_Up x,y :GUI BITMAP x+2,y+4,but$(f%),16,11,1,col%(7),col%(10)
  Next
  rstDsp :paint :setBlk
End Sub

Sub paint 'shows the Sprite top right
  Local integer x,y
  For y=0 To SH-1:For x=0 To SW-1:Pixel xofs+x,yofs+y,Buff%(y*SW+x):Next :Next
  'Box 0,0,241,240,,Col%(7)
End Sub

Sub But_Up(x,y)
  Box x,y,20,20,,col%(2),col%(2)
  Box x+1,y+1,19,19,,col%(8),col%(8)
  Box x+1,y+1,18,18,,col%(10),col%(10)
End Sub
Function compress$(search$)
Local String from$,zu$
 found=0
 For f%=0 To 15
   For n%=16 To 3 Step -1
     from$=String$(n%,Hex$(f%,1))
     zu$=Chr$(71+f%)+Chr$(128+Asc(Hex$(n%-1,1)))
    'addition of 128 prevents the results from
     'being incorrectly counted in a further search
     Do
       search$=replace$(from$,zu$,search$)
       If found=0 Then Exit
     Loop
   Next n%
 Next f%
 compress$=""
 For f%=1 To Len(search$)
   n%=Asc(Mid$(search$,f%,1))
   n%=n%-128*(n%>128):'sub the 128 if needed
   compress$=compress$+Chr$(n%)
 Next
End Function
'
Function replace$(sr$,repl$,sear$)
Local n%,tmp$
tmp$=" "+sear$+" "
found=Instr(tmp$,sr$)
If found=0 Then replace$=sear$:Exit Function
tmp$=Left$(tmp$,found-1)+repl$+Right$(tmp$,Len(tmp$)-(found+Len(sr$))+1)
replace$=Mid$(tmp$,2,Len(tmp$)-2)
End Function


buttons:
Data 256,66,278,66,300,66
Data 278,96,300,96
Data 278,118,300,118
Data 278,145,300,145
Data 278,172,300,172
Data 278,194,300,194
Data 278,220,300,220

colors:
'--Colorscheme accordung to matherp
Data RGB(BLUE),RGB(GREEN),RGB(CYAN),RGB(RED)
Data RGB(MAGENTA),RGB(YELLOW),RGB(WHITE),RGB(MYRTLE)
Data RGB(COBALT) ,RGB(MIDGREEN),RGB(CERULEAN),RGB(RUST)
Data RGB(FUCHSIA),RGB(BROWN),RGB(LILAC)

pict:
'Icon Data
Data 127,0,65,128,65,64,65,224,64,32,64,32,64,32,64,41,64,45,64
Data 43,127,233,232,64,136,224,201,240,136,0,0,64,0,64,0,64,64,1
Data 127,255,64,1,127,255,238,64,130,64,196,64,142,0,1,240,0,224
Data 0,64,64,1,127,255,64,1,127,255,2,0,6,0,14,0,30,0,62,252,30
Data 0,14,6,6,9,2,13,0,10,0,5,0,64,0,96,0,112,0,120,63,124,0
Data 120,0,112,0,96,0,81,0,21,0,10,0,0,1,0,3,128,7,192,15,224
Data 0,0,1,6,1,9,1,9,1,9,0,6,0,0,1,0,1,0,1,0,1,0,0,0,15,233
Data 7,202,3,140,1,10,0,9,15,240,8,16,8,16,127,144,64,144,64,144
Data 64,151,64,244,64,135,127,129,0,7,31,240,32,8,79,228,64,4,64
Data 4,65,255,65,0,65,7,65,5,127,6,1,244,7,224,24,24,32,4,32,2
Data 248,2,112,2,32,2,0,4,0,20,0,228,0,7,7,224,24,24,32,4,64,4
Data 64,31,64,14,64,0,32,7,24,5,7,6,0,5,0,0,1,128,0,0,33,132,96
Data 6,239,247,96,6,33,132,0,5,1,135,0,5,0,128,1,192,3,224,0,0
Data 42,170,42,170,0,128,0,5,3,229,1,197,0,130,1,0,3,0,55,252,67
Data 2,65,2,64,2,64,130,64,194,63,236,0,192,0,128,0,0,0,0,31,248
Data  31,248,31,248,31,248,31,248,31,248,31,248,0,0,0,0
